# -*- coding:utf-8 -*-
from Core.bottle import Bottle, debug, jinja2_template as template, TEMPLATE_PATH, static_file, request, response
from setting import STORAGE_DOMAIN_NAME

import sae.storage, time
app = Bottle()
debug(True)
TEMPLATE_PATH.append('static/template/')

@app.get('/static/<filename:re:.*[^/]>')
def server_static_file(filename):
    return static_file(filename, root='./static/')

@app.get('/index')
@app.get('/')
def index():
    return 'index'

@app.get('/upload')
def upload():
    return template("upload.html")

@app.post('/upload_c')
def upload_c_post():
    data = request.files.get('Filedata')
    _filetype = data.filename.split('.')[-1].lower()
    _filename = '%s.%s'%(str(int(time.time())), _filetype)
    _content_type='image/%s'%_filetype
    _content = data.file.read()
    put_obj2storage(_filename, _content, expires='365', type=_content_type)
    return _filename

@app.get('/img/<filename:re:.*[^/]>')
def get_img(filename):
    _filetype = filename.split('.')[-1]
    response.add_header('Content-type', 'image/%s'%_filetype)
    return get_obj_from_storage(filename)

def put_obj2storage(file_name = '', data = '', expires='365', type=None, encoding= None, domain_name = STORAGE_DOMAIN_NAME):
    '''存进storage'''
    s = sae.storage.Client()
    ob = sae.storage.Object(data = data, cache_control='access plus %s day' % expires, content_type= type, content_encoding= encoding)
    return s.put(domain_name, file_name, ob)

def get_obj_from_storage(file_name = '', domain_name = STORAGE_DOMAIN_NAME):
    '''从storage中获取数据'''
    s = sae.storage.Client()
    ob = s.get(domain_name, file_name)
    return ob.data
